﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr137_2
{
    // Класс с индексатором: 
    class MyClass
    {
        // Закрытое числовое поле: 
        private int num;
        // Конструктор с текстовым аргументом: 
        public MyClass(int t)
        {
            num = t;
        }
        // Переопределение метода ToString(): 
        public override string ToString()
        {
            // Текстовая переменная:
            string txt = "Содержимое объекта: " + num;
            // Результат метода: 
            return txt;
        }
        // Числовой индексатор с целочисленным индексом: 
        public int this[int k]
        {
            // Метод вызывается при присваивании значения 
            // выражению с индексированным объектом: 
            set
            {
                int res = value % 10;
                // Проверка значения индекса: 
                if (k < 0 || k >= (num.ToString()).Length) return;
                // Числовая переменная: 
                int t = 0;
                int ch = num;
                // Добавление цифр к числу: 
                for (int i = 0; i < k; i++)
                {
                    t += (ch % 10) * Convert.ToInt32(Math.Pow(10, i));
                    ch /= 10; 
                }
                // Добавление к числу нужной цифры: 
                t += res * Convert.ToInt32(Math.Pow(10, k));
                ch /= 10; 
                // Добавление цифр к числу: 
                for (int i = k + 1; i < (num.ToString()).Length; i++)
                {
                    t += (ch % 10) * Convert.ToInt32(Math.Pow(10, i));
                    ch /= 10; 
                }
                // Новое значение числа: 
                num = t;
            }
        }
    }

    // Класс с главным методом: 
    class Program
    {
        // Главный метод:
        static void Main()
        {
            // Создание объекта:
            MyClass obj = new MyClass(357);
            // Проверка содержимого объекта:
            Console.WriteLine(obj);
            // Попытка изменить цифру в числе: 
            obj[-1] = 111;
            // Проверка содержимого объекта:
            Console.WriteLine(obj);
            // Попытка изменить цифру в числе: 
            obj[8] = 88;
            // Проверка содержимого объекта:
            Console.WriteLine(obj);
            // Изменение цифры в числе: 
            obj[0] = 999;
            // Проверка содержимого объекта:
            Console.WriteLine(obj);
            // Изменение цифры в числе: 
            obj[2] = 776;
            // Проверка содержимого объекта:
            Console.WriteLine(obj);
            // Изменение цифры в числе: 
            obj[1] = 34;
            // Проверка содержимого объекта:
            Console.WriteLine(obj);
            // Задержка:
            Console.ReadLine();
        }
    }
}
